{$A+}{$B-}{$F-}{$G+}{$I+}{$Q-}{$R-}{$S-}{$X+}{$M 16384,65536,655360}

PROGRAM EeulPlek;

uses Crt, EeulScrn, Dos, Enemy4, Data01, Data02;

var
   buffer: pointer;

procedure wait_vblank; near; assembler;
asm
            mov     dx,     $3d4
            mov     ax,     $0000c
            out     dx,     ax
            mov     dx,     $3da
@wv2:       in      al,     dx
            and     al,     8
            jnz     @wv2
@wn2:       in      al,     dx
            and     al,     8
            jz      @wn2
end;
procedure init_mode3; near; assembler;
asm
            mov     ax,     3
            int     $10
end;

procedure display_screen; near; assembler;
asm
            push    ds
            mov     di,     $0a000
            mov     es,     di
            xor     di,     di
            lds     si,     buffer
            add     si,     32
            mov     ax,     64
            mov     bx,     200
            mov     dx,     128
@1:         mov     cx,     dx
        rep movsw
            add     si,     ax
            add     di,     ax
            dec     bx
            jnz     @1
            pop     ds
end;

procedure clear_screen; near; assembler;
asm
            les     di,     buffer
            add     di,     32
            mov     si,     64
            xor     ax,     ax
            mov     dx,     128
            mov     bx,     200
@1:         mov     cx,     dx
        rep stosw
            add     di,     si
            dec     bx
            jnz     @1
end;

procedure draw_spritew(sprite: Pointer; x, y: integer); near; assembler;
asm
            push    ds
            les     di,     buffer
            mov     cx,     y
            cmp     cx,     199
            jg      @end
            or      cx,     cx
            jg      @not_top
            add     di,     x
            lds     si,     sprite
            lodsb
            cbw
            mov     bx,     ax
            lodsb
            cbw
            add     ax,     y
            jle     @end
            mov     cx,     ax
            mov     ax,     y
            neg     ax
            mul     bx
            add     si,     ax
            jmp     @clipped
@not_top:   mov     ax,     320
            mul     cx
            add     ax,     x
            add     di,     ax
            lds     si,     sprite
            lodsb
            cbw
            mov     bx,     ax
            lodsb
            cbw
            mov     cx,     ax
            add     ax,     y
            sub     ax,     200
            jle     @clipped
            sub     cx,     ax
@clipped:   mov     dx,     320
            sub     dx,     bx
@main_loop: push    cx
            mov     cx,     bx
@line_loop: lodsb
            or      al,     al
            jz      @no_plot
            mov     al,     -1
            stosb
            loop    @line_loop
@ll_end:    add     di,     dx
            pop     cx
            loop    @main_loop
            jmp     @end
@no_plot:   inc     di
            loop    @line_loop
            jmp     @ll_end
@end:       pop     ds
end;


procedure draw_sprite(sprite: Pointer; x, y: integer); near; assembler;
asm
            push    ds
            les     di,     buffer
            mov     cx,     y
            cmp     cx,     199
            jg      @end
            or      cx,     cx
            jg      @not_top
            add     di,     x
            lds     si,     sprite
            lodsb
            cbw
            mov     bx,     ax
            lodsb
            cbw
            add     ax,     y
            jle     @end
            mov     cx,     ax
            mov     ax,     y
            neg     ax
            mul     bx
            add     si,     ax
            jmp     @clipped
@not_top:   mov     ax,     320
            mul     cx
            add     ax,     x
            add     di,     ax
            lds     si,     sprite
            lodsb
            cbw
            mov     bx,     ax
            lodsb
            cbw
            mov     cx,     ax
            add     ax,     y
            sub     ax,     200
            jle     @clipped
            sub     cx,     ax
@clipped:   mov     dx,     320
            sub     dx,     bx
@main_loop: push    cx
            mov     cx,     bx
@line_loop: lodsb
            or      al,     al
            jz      @no_plot
            stosb
            loop    @line_loop
@ll_end:    add     di,     dx
            pop     cx
            loop    @main_loop
            jmp     @end
@no_plot:   inc     di
            loop    @line_loop
            jmp     @ll_end
@end:       pop     ds
end;

const
   max_your_bullets = 20;
   num_small_stars = 50;
   num_large_stars = 25;
   num_stars = num_small_stars + num_large_stars;
   max_enemies = 12;
   max_enemy_bullets = 40;
   num_weapons = 1;
   ebuls = 16;

type                          { Player bullet structure }
   player_bullet = record
      b_t: integer;
      b_x: integer;
      b_y: integer;
      b_xv: integer;
      b_yv: integer;
      b_d: integer;
      b_w: integer;
      b_h: integer;
   end;

type                          { Enemy bullet strucrure }
   enemy_bullet = record
      eb_t: integer;
      eb_x: integer;
      eb_y: integer;
      eb_xv: integer;
      eb_yv: integer;
   end;

type                          { Enemy data structure }
    enemy = record
       e_t: integer;
       e_c: integer;
       e_x: integer;
       e_y: integer;
       e_xv: integer;
       e_yv: integer;
       e_w: integer;
       e_h: integer;
       e_d: integer;
       e_m1: integer;
       e_m2: integer;
       e_m3: integer;
       e_jh: integer;
       e_ptr: ^Pointer;
    end;

var
   a: char;
   x: integer;
   y: integer;
   starsx: array[1..num_stars] of integer;
   starsy: array[1..num_stars] of integer;
   player_bullets: array[1..max_your_bullets] of player_bullet;
   star: integer;
   delta, deltax, deltay: integer;
   firecounter: integer;
   weapon: integer;
   selectcounter: integer;
   regs: Registers;
   t1, t2, t3, t4: integer;
   mb: integer;
   power: array[1..8] of integer;
   ecounter: integer;
   epointer: integer;
   enemies: array[1..max_enemies] of enemy;
   shield:integer;
   enemy_bullets: array[1..ebuls] of enemy_bullet;
   jh: integer;
   tptr: Pointer;
   tptr2: ^longint;
   val: longint;
   clock: longint;
   real_time: longint;
   Hour, Minute, Second, Sec100, Sec100_2: Word;

const
   large_star: array[1..11] of byte = (3,3,0,119,0,119,112,119,0,119,0);
   small_star: array[1..11] of byte = (3,3,0,120,0,120,116,120,0,120,0);

const
   num_enemies = 36;
   enemy_data: array[0..(num_enemies * 8) - 1] of integer = (
   100,2,296,80,9,0,0,0
   ,30,2,296,60,9,0,0,0
   ,180,5,60,-20,15,0,0,0
   ,2,5,50,-30,15,0,0,0
   ,2,5,40,-40,15,0,0,0
   ,200,1,36,-30,12,0,0,0
   ,20,1,80,-30,12,0,0,0
   ,20,1,124,-30,12,0,0,0
   ,250,3,36,-10,18,0,0,0
   ,2,3,268,-10,18,0,0,0
   ,150,2,296,80,12,0,0,0
   ,30,2,296,60,12,0,0,0
   ,30,2,296,40,12,0,0,0
   ,250,1,36,-30,20,0,0,0
   ,20,1,80,-30,20,0,0,0
   ,20,1,124,-30,20,0,0,0
   ,250,4,36,-30,480,0,0,0
   ,-1,5,80,-20,15,0,0,0
   ,2,5,70,-30,15,0,0,0
   ,2,5,60,-40,15,0,0,0
   ,2,5,50,-50,15,0,0,0
   ,2,5,40,-60,15,0,0,0
   ,180,3,36,-10,18,0,0,0
   ,2,3,268,-10,18,0,0,0
   ,20,3,76,-10,18,0,0,0
   ,2,3,228,-10,18,0,0,0
   ,20,3,116,-10,18,0,0,0
   ,2,3,188,-10,18,0,0,0
   ,20,3,136,-10,18,0,0,0
   ,2,3,168,-10,18,0,0,0
   ,250,4,36,-30,580,0,0,0
   ,20,4,236,-30,580,0,0,0
   ,-1,2,296,80,12,0,0,0
   ,20,2,296,60,12,0,0,0
   ,20,2,296,40,12,0,0,0
   ,20,2,296,20,12,0,0,0
);

procedure pset(x, y, c: integer);
begin
   Mem[$A000: x + (320 * y)] := c;
end;

{ Enemy firing routine}

procedure fire(initialx, initialy, targetx, targety, speed: integer);
var
   deltax, deltay, t50, dist: integer;
begin
   deltax := targetx - initialx;
   deltay := targety - initialy;
   dist := Abs(deltax) + Abs(deltay);
   if dist < 1 then
      Exit;
   for t50 := 1 to ebuls do begin
      with enemy_bullets[t50] do begin
         if eb_t = 0 then begin
            eb_t := 1;
            eb_x := initialx * 16;
            eb_y := initialy * 16;
            eb_xv := deltax * speed div dist;
            eb_yv := deltay * speed div dist;
            Exit;
         end;
      end;
   end;
end;

procedure fire2(initialx, initialy, targetx, targety: integer);
var
   deltax, deltay, t50, dist: integer;
begin
   deltax := targetx - initialx;
   deltay := targety - initialy;
   dist := Abs(deltax) + Abs(deltay);
   if dist < 1 then
      Exit;
   for t50 := 1 to ebuls do begin
      with enemy_bullets[t50] do begin
         if eb_t = 0 then begin
            eb_t := 2;
            eb_x := initialx * 16;
            eb_y := initialy * 16;
            eb_xv := deltax * 28 div dist;
            eb_yv := deltay * 28 div dist;
            Exit;
         end;
      end;
   end;
end;


{ Damage enemies when they are hit }

procedure enemy_hit(enemy_number,damage:integer);
begin
   with enemies[enemy_number] do begin
      e_d := e_d - damage;
      e_jh := e_jh + 4;
      if e_d < 0 then begin
         case e_t of
            1: begin
               e_t := - 1;
               e_ptr := @enemy_1_death;
            end;
            2: begin
               e_t := -1;
               e_ptr := @enemy_2_death;
            end;
            3: begin
               e_t := -1;
               e_ptr := @enemy_3_death;
            end;
            4: begin
               e_t := -1;
               e_ptr := @enemy_4_death;
            end;
            5..7: begin
               e_t := -1;
               e_ptr := @enemy_general_death;
            end;
         else
            e_t := 0;
         end;
      end;
   end;
end;

begin
   HighVideo;
   ClrScr;
   Writeln;
   Writeln('                        E E U L P L E K     0 . 4');
   Writeln;
   Writeln('                Copyright 1997 - 1999 by Patrick Davidson');
   Writeln;
   Writeln;
   Writeln;
   Writeln('                         Press any key to begin.');
   repeat
   until Keypressed;
   regs.ax := 7;
   regs.cx := 64;
   regs.bx := 64;
   Intr($33, regs);
   GetMem(buffer, 64000);
   regs.ax := 4;
   regs.cx := 32;
   regs.dx := 32;
   Intr($33, regs);
   if not(buffer = nil) then begin
      a := ' ';
      set_up_display;
      x := 150;
      y := 180;
      weapon := 1;
      ecounter := 0;
      epointer := 0;
      shield := 56;
      for t1 := 1 to shield do begin
         pset(259 + t1, 62, 255);
         pset(260 + t1, 63, 0);
      end;
      for t1:=1 to 8 do power[t1]:=1;
      Randomize;
      for star := 1 to num_small_stars do begin
         starsx[star] := 32 + Random(254);
         starsy[star] := Random(205) - 4;
      end;
      for star := num_small_stars + 1 to num_stars do begin
         starsx[star] := 32 + Random(254);
         starsy[star] := Random(205) - 4;
      end;
      clear_screen;
      repeat

         { Screen Display / Keyboard Input}

         wait_vblank;
         GetTime(Hour, Minute, Second, Sec100);
         display_screen;
         a := '_';
         if Keypressed then a := ReadKey;
         clear_screen;

         { Draw Stars }

         for star:=1 to num_small_stars do begin
            draw_sprite(@small_star,starsx[star],starsy[star]);
            starsy[star]:=starsy[star]+1;
            if starsy[star]>200 then begin
               starsy[star]:=-5;
               starsx[star]:=32+Random(254);
            end;
         end;
         for star:=num_small_stars+1 to num_stars do begin
            draw_sprite(@large_star,starsx[star],starsy[star]);
            starsy[star]:=starsy[star]+2;
            if starsy[star]>200 then begin
               starsy[star]:=-5;
               starsx[star]:=32+Random(254);
            end;
         end;

         { Manage Your Ship / Mouse Input }

         if jh > 0 then begin
            jh := jh - 1;
            draw_spritew(@sprite_you_1, x, y);
         end else draw_sprite(@sprite_you_1, x, y);
         regs.ax := 3;
         Intr($33, regs);
         mb := regs.bx;

         deltax := deltax + regs.cx - 32;
         if deltax > 32 then deltax := 32;
         if deltax < -32 then deltax := -32;
         if (deltax >= -4) and (deltax <= 4) then begin
            delta := deltax;
            deltax := 0;
         end;
         if deltax < -4 then begin
            delta := -4;
            deltax := deltax + 4;
         end;
         if deltax > 4 then begin
            delta := 4;
            deltax := deltax - 4;
         end;
         x := x + delta;

         deltay := deltay + regs.dx - 32;
         if deltay > 32 then deltay := 32;
         if deltay < -32 then deltay := -32;
         if (deltay >= -4) and (deltay <= 4) then begin
            delta := deltay;
            deltay := 0;
         end;
         if deltay < -4 then begin
            delta := -4;
            deltay := deltay + 4;
         end;
         if deltay > 4 then begin
            delta := 4;
            deltay := deltay - 4;
         end;
         y := y + delta;

         regs.ax := 4;
         regs.cx := 32;
         regs.dx := 32;
         Intr($33, regs);
         if x < 32 then x := 32;
         if x > 264 then x := 264;
         if y > 186 then y := 186;
         if y < 120 then y := 120;
         if a = 'p' then begin
            repeat
            until Keypressed;
         end;

         { Allow you to fire bullets }

         if (mb and 1) = 1 then begin
            if firecounter > 0 then begin
               firecounter := firecounter - 1;
            end else begin
               firecounter := 12;
               case weapon of
                  1: begin
                     t1 := 1;
                     t2 := 0;
                     while (t1 < max_your_bullets) and (t2 = 0) do begin
                        with player_bullets[t1] do begin
                           if b_t = 0 then begin
                              b_t := 1;
                              b_x := x;
                              b_y := y - 6;
                              b_w := 7;
                              b_h := 12;
                              b_d := 4 + power[1];
                              t2 := 1
                           end;
                           t1 := t1 + 1;
                        end;
                     end;
                     t2 := 0;
                     while (t1 < max_your_bullets) and (t2 = 0) do begin
                        with player_bullets[t1] do begin
                           if b_t =0 then begin
                              b_t := 1;
                              b_x := x + 17;
                              b_y := y - 6;
                              b_w := 7;
                              b_h := 12;
                              b_d := 4 + power[1];
                              t2 := 1;
                           end;
                           t1 := t1 + 1;
                        end;
                     end;
                  end;
               end;
            end;
         end else begin
            firecounter:=0;
         end;

         { Move your bullets}

         for t1 := 1 to max_your_bullets do begin
            with player_bullets[t1] do begin
               case b_t of
                  1: begin
                     b_y := b_y - 6;
                     if b_y < -10 then b_t := 0;
                     draw_sprite(@disruptor_blast_1, b_x, b_y);
                  end;
               end;
            end;
         end;

         { Enemy bullets }

         for t1 := 1 to ebuls do begin
            with enemy_bullets[t1] do begin
               case eb_t of
                  1: begin
                     eb_x := eb_x + eb_xv;
                     eb_y := eb_y + eb_yv;
                     if eb_x < 384 then eb_t := 0;
                     if eb_x > 4608 then eb_t := 0;
                     if eb_y < 0 then eb_t := 0;
                     if eb_y > 3200 then eb_t :=0;
                     draw_sprite(@ebul1, eb_x shr 4, eb_y shr 4);
                     if eb_x shr 4 <= x + 24 then begin
                        if (eb_x shr 4) + 7 >= x then begin
                           if eb_y shr 4 <= y + 14 then begin
                              if (eb_y shr 4) + 7 >= y then begin
                                 eb_t := 0;
                                 pset(259 + shield, 62, 28);
                                 pset(260 + shield, 63, 28);
                                 shield := shield - 1;
                                 jh := jh + 4;
                              end;
                           end;
                        end;
                     end;
                  end;
                  2: begin
                     eb_x := eb_x + eb_xv;
                     eb_y := eb_y + eb_yv;
                     if eb_x < 384 then eb_t := 0;
                     if eb_x > 4608 then eb_t := 0;
                     if eb_y < 0 then eb_t := 0;
                     if eb_y > 3200 then eb_t :=0;
                     case (clock shr 1) and 3 of
                        0: draw_sprite(@ebul2_0, eb_x shr 4, eb_y shr 4);
                        1: draw_sprite(@ebul2_1, eb_x shr 4, eb_y shr 4);
                        2: draw_sprite(@ebul2_2, eb_x shr 4, eb_y shr 4);
                        3: draw_sprite(@ebul2_3, eb_x shr 4, eb_y shr 4);
                     end;
                     if eb_x shr 4 <= x + 24 then begin
                        if (eb_x shr 4) + 7 >= x then begin
                           if eb_y shr 4 <= y + 14 then begin
                              if (eb_y shr 4) + 7 >= y then begin
                                 eb_t := 0;
                                 pset(259 +shield, 62, 28);
                                 pset(260 +shield, 63, 28);
                                 shield := shield - 1;
                                 pset(259 + shield, 62, 28);
                                 pset(260 + shield, 63, 28);
                                 shield := shield - 1;
                                 jh := jh + 4;
                              end;
                           end;
                        end;
                     end;
                  end;
               end;
            end;
         end;
         if shield<0 then Break;

         { Create enemies }

         t4 := 0;
         for t1 := 1 to max_enemies do begin
            if enemies[t1].e_t <> 0 then begin
               t4 := 1;
               Break;
            end;
         end;
         t3 := enemy_data[epointer];
         ecounter := ecounter + 1;
         if ((t3 > 0) and (ecounter = t3)) or ((t4 = 0) and (t3 = -1)) then begin
            ecounter := 0;
            t1 := 1;
            t2 := 0;
            while (t1 < max_enemies) and (t2 = 0) do begin
               with enemies[t1] do begin
                  if e_t = 0 then begin
                     e_t := enemy_data[epointer + 1];
                     e_x := enemy_data[epointer + 2];
                     e_y := enemy_data[epointer + 3];
                     e_d := enemy_data[epointer + 4];
                     e_c := 0;
                     e_jh := 0;
                     case e_t of
                        1: begin
                           e_w := 22;
                           e_h := 12;
                        end;
                        2: begin
                           e_w := 16;
                           e_h := 13;
                        end;
                        3: begin
                           e_w := 15;
                           e_h := 10;
                        end;
                        4: begin
                           e_w := 48;
                           e_h := 28;
                           e_xv := 0;
                           e_yv := 1;
                        end;
                        5: begin
                           e_w := 15;
                           e_h := 14;
                        end;
                     end;
                     epointer := epointer + 8;
                     if epointer = num_enemies * 8 then epointer := 0;
                     t2 := 1;
                  end;
                  t1 := t1 + 1;
               end;
            end;
         end;

         { Operate enemies }

         for t1 := 1 to max_enemies do begin
            with enemies[t1] do begin
               e_c := e_c +1 ;
               case e_t of
                  -1: begin { Exploding enemy }
                     tptr := e_ptr^;
                     draw_sprite(tptr, e_x, e_y);
                     if (clock and 1) = 1 then begin
                        tptr2 := Addr(e_ptr);
                        tptr2^ := tptr2^ + 4;
                        if e_ptr^ = nil then e_t := 0;
                     end;
                  end;
                  1: begin { U-sweeping orange enemies }
                     if (e_c and 127) = 42 then begin
                        fire(e_x + 7, e_y + 8, x + 9, y + 3, 20 + e_d);
                     end;
                     case e_c of
                        0..100: e_y := e_y + 1;
                        101..120: begin
                           e_x := e_x + 1;
                           e_y := e_y + 1;
                        end;
                        121..220: e_x := e_x + 1;
                        221..240: begin
                           e_y := e_y - 1;
                           e_x := e_x + 1;
                        end;
                        241..340: e_y := e_y - 1;
                        341: e_t := 0;
                     end;
                     if e_jh > 0 then begin
                        e_jh := e_jh - 1;
                        draw_spritew(@enemy_1, e_x, e_y);
                     end else
                     draw_sprite(@enemy_1, e_x, e_y);
                  end;
                  2: begin { Directly attacking red enemies }
                     e_x := e_x - 2;
                     if e_x < 10 then e_t := 0;
                     if e_jh > 0 then begin
                        e_jh := e_jh - 1;
                        draw_spritew(@enemy_2, e_x, e_y);
                     end else
                     draw_sprite(@enemy_2, e_x, e_y);
                     if (e_x = 240) or (e_x = 46) then
                        fire(e_x + 7, e_y + 5, x + 9, y + 3, 20);
                  end;
                  3: begin
                     e_y := e_y + 2;
                     if e_y > 198 then e_t := 0;
                     if e_jh > 0 then begin
                        e_jh := e_jh - 1;
                        draw_spritew(@enemy_3, e_x, e_y);
                     end else
                     draw_sprite(@enemy_3, e_x, e_y);
                     if (e_y and 63) = 26 then
                        fire(e_x + 4, e_y + 3, x + 9, y + 3, 20);
                  end;
                  5: begin
                     e_y := e_y + 2;
                     if e_y = 100 then e_t := 6;
                     if e_jh > 0 then begin
                        e_jh := e_jh - 1;
                        draw_spritew(@enemy_5, e_x, e_y);
                     end else
                        draw_sprite(@enemy_5, e_x, e_y);
                     if clock and 63 = t1 then
                        fire2(e_x + 5, e_y + 5, x + 10, y + 4);
                  end;
                  6: begin
                     e_y := e_y + 1;
                     e_x := e_x + 1;
                     if e_y = 120 then e_t := 7;
                     if e_jh > 0 then begin
                        e_jh := e_jh - 1;
                        draw_spritew(@enemy_6, e_x, e_y);
                     end else
                        draw_sprite(@enemy_6, e_x, e_y);
                     if clock and 63 = t1 then
                        fire2(e_x + 5, e_y + 5, x + 10, y + 4);
                  end;
                  7: begin
                     e_x := e_x + 1;
                     if e_x > 288 then e_t := 0;
                     if e_jh > 0 then begin
                        e_jh := e_jh - 1;
                        draw_spritew(@enemy_7, e_x, e_y);
                     end else
                        draw_sprite(@enemy_7, e_x, e_y);
                     if clock and 63 = t1 then
                        fire2(e_x + 5, e_y + 5, x + 10, y + 4);
                  end;
                  4: begin
                     e_x := e_x + e_xv;
                     e_y := e_y + e_yv;
                     if (e_x = 36) and (e_y = 5) then begin
                        case Random(3) of
                           0: begin
                              e_xv := 1;
                              e_yv := 0;
                           end;
                           1: begin
                              e_xv := 1;
                              e_yv := 1;
                           end;
                           2: begin
                              e_xv := 0;
                              e_yv := 1;
                           end;
                        end;
                     end;
                     if (e_x = 36) and (e_y = 105) then begin
                        case Random(3) of
                           0: begin
                              e_xv := 1;
                              e_yv := 0;
                           end;
                           1: begin
                              e_xv := 1;
                              e_yv := -1;
                           end;
                           2: begin
                              e_xv := 0;
                              e_yv := -1;
                           end;
                        end;
                     end;
                     if (e_x = 136) and (e_y = 5) then begin
                        case Random(5) of
                           0: begin
                              e_xv := 1;
                              e_yv := 0;
                           end;
                           1: begin
                              e_xv := 1;
                              e_yv := 1;
                           end;
                           2: begin
                              e_xv := 0;
                              e_yv := 1;
                           end;
                           3: begin
                              e_xv := -1;
                              e_yv := 1;
                           end;
                           4: begin
                              e_xv := -1;
                              e_yv := 0;
                           end;
                        end;
                     end;
                     if (e_x = 136) and (e_y = 105) then begin
                        case Random(5) of
                           0: begin
                              e_xv := 1;
                              e_yv := 0;
                           end;
                           1: begin
                              e_xv := 1;
                              e_yv := -1;
                           end;
                           2: begin
                              e_xv := 0;
                              e_yv := -1;
                           end;
                           3: begin
                              e_xv := -1;
                              e_yv := -1;
                           end;
                           4: begin
                              e_xv := -1;
                              e_yv := 0;
                           end;
                        end;
                     end;
                     if (e_x = 236) and (e_y = 5) then begin
                        case Random(3) of
                           0: begin
                              e_xv := -1;
                              e_yv := 0;
                           end;
                           1: begin
                              e_xv := -1;
                              e_yv := 1;
                           end;
                           2: begin
                              e_xv := 0;
                              e_yv := 1;
                           end;
                        end;
                     end;
                     if (e_x = 236) and (e_y = 105) then begin
                        case Random(3) of
                           0: begin
                              e_xv := -1;
                              e_yv := 0;
                           end;
                           1: begin
                              e_xv := -1;
                              e_yv := -1;
                           end;
                           2: begin
                              e_xv := 0;
                              e_yv := -1;
                           end;
                        end;
                     end;
                     case e_d of
                        200..999: begin
                           if e_jh > 0 then begin
                              e_jh := e_jh - 1;
                              draw_spritew(@enemy_4a, e_x, e_y);
                           end else
                              draw_sprite(@enemy_4a, e_x, e_y);
                           if (e_c and 31) = 26 then
                              fire(e_x, e_y + 22, x + 9, y + 3,18);
                           if (e_c and 31) = 27 then
                              fire(e_x + 41, e_y + 22, x + 9, y + 3, 18);                     end;
                        100..199: begin
                           if e_jh > 0 then begin
                              e_jh := e_jh - 1;
                              draw_spritew(@enemy_4b, e_x, e_y);
                           end else
                              draw_sprite(@enemy_4b, e_x, e_y);
                           if e_c and 31 = 26 then
                              fire(e_x, e_y + 22, x + 9, y + 3, 18);
                        end;
                        else begin
                           if e_jh > 0 then begin
                              e_jh := e_jh - 1;
                              draw_spritew(@enemy_4c, e_x, e_y);
                           end else
                              draw_sprite(@enemy_4c, e_x, e_y);
                           if e_c and 31 = 26 then
                              fire(e_x, e_y + 22, x + 9, y + 3, 13);
                        end;
                     end;
                  end;
               end;
            end;
         end;

         { Collisions between enemies and you }

         for t1 := 1 to max_enemies do begin
            with enemies[t1] do begin
               if e_t <> 0 then begin
                  if e_y + e_h >= y  then begin
                     if e_y <= y + 14 then begin
                        if e_x <= x + 24 then begin
                           if e_x + e_w >= x then begin
                              pset(259 + shield, 62, 28);
                              pset(260 + shield, 63, 28);
                              shield := shield - 1;
                              pset(259 + shield, 62, 28);
                              pset(260 + shield, 63, 28);
                              shield := shield - 1;
                              jh := jh + 1;
                              enemy_hit(t1, 1);
                           end;
                        end;
                     end;
                  end;
               end;
            end;
         end;

         { Collisions between your bullets and enemies }

         for t1 := 1 to max_your_bullets do begin
            with player_bullets[t1] do begin
               if b_t <> 0 then begin
                  for t2 := 1 to max_enemies do begin
                     with enemies[t2] do begin
                        if e_t > 0 then begin
                           if e_x <= b_x + b_w then begin
                              if e_x + e_w >= b_x then begin
                                 if e_y <= b_y + b_h then begin
                                    if e_y + e_h >= b_y then begin
                                       enemy_hit(t2, b_d);
                                       b_t := 0;
                                       Break;
                                    end;
                                 end;
                              end;
                           end;
                        end;
                     end;
                  end;
               end;
            end;
         end;
         GetTime(Hour, Minute, Second, Sec100_2);
         real_time := real_time + (100 + Sec100_2 - Sec100) mod 100;
         clock := clock + 1;
      until (a = 'q') or (a = 'Q');
      FreeMem(buffer, 64000);
   end;

   init_mode3;
   Writeln('-= EeulPlek =-   Version 0.2   Copyright 1997 - 1999 by Patrick Davidson');
   Writeln('Average frame time : ', real_time * 10 / clock : 5 : 6, ' milliseconds.');
end.